"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EntityProxy = void 0;
const entity_1 = require("./entity");
const debug_1 = __importDefault(require("debug"));
const log = (0, debug_1.default)("sourced");
const proxyConstructor = {
    apply: (Target, thisArg, args) => {
        log(`Initializing ${Target.name} with:`, args);
        const entity = new Target();
        Object.assign(thisArg, entity);
        thisArg.rehydrate(...args);
    },
};
exports.EntityProxy = new Proxy(entity_1.Entity, proxyConstructor);
